/*
 * @Description: 
 * @Date: 2020-04-02 21:44:31
 * @LastEditors: CK.Zh
 * @LastEditTime: 2021-03-10 10:56:36
 * @FilePath: \NaviKit_EC_stm32\Core\Src\freertos.c
 */
/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * File Name          : freertos.c
  * Description        : Code for freertos applications
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2020 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under Ultimate Liberty license
  * SLA0044, the "License"; You may not use this file except in compliance with
  * the License. You may obtain a copy of the License at:
  *                             www.st.com/SLA0044
  *
  ******************************************************************************
  */

//TODO:拆分该文件中的功能到不同的文件中，按照任务进行模块化拆分
#define LOG_TAG	"RTOS"
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/

#include "FreeRTOS.h"
#include "task.h"
#include "main.h"
#include "cmsis_os.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "timers.h"
#include "navikit.h"
#include <th_cdc.h>
#include <th_demo.h>
#include <th_elog.h>
#include <th_led.h>
#include <th_coulomb.h>
#include <th_power.h>
#include <th_button.h>


/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN Variables */



//Thread





//Queue
//osMessageQueueId_t LogMessageQueueHandle;
//const osMessageQueueAttr_t LogMessageQueue_attributes = {
//  .name = "LogMessageQueue"
//};

/* USER CODE END Variables */
/* Definitions for defaultTask */
osThreadId_t defaultTaskHandle;
const osThreadAttr_t defaultTask_attributes = {
  .name = "defaultTask",
  .priority = (osPriority_t) osPriorityNormal,
  .stack_size = 128 * 4
};





/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN FunctionPrototypes */

bool isWakeUpReset() {	return  __HAL_PWR_GET_FLAG(PWR_FLAG_WU);}

void IdleStateHoldTimerCallback(void *argument);



/* USER CODE END FunctionPrototypes */

void StartDefaultTask(void *argument);

extern void MX_USB_DEVICE_Init(void);
void MX_FREERTOS_Init(void); /* (MISRA C 2004 rule 8.1) */

/* Hook prototypes */
void configureTimerForRunTimeStats(void);
unsigned long getRunTimeCounterValue(void);
void vApplicationIdleHook(void);
void vApplicationTickHook(void);
void vApplicationStackOverflowHook(xTaskHandle xTask, signed char *pcTaskName);

/* USER CODE BEGIN 1 */
/* Functions needed when configGENERATE_RUN_TIME_STATS is on */
__weak void configureTimerForRunTimeStats(void)
{

}

__weak unsigned long getRunTimeCounterValue(void)
{
//	return osKernelGetTickCount();
}
/* USER CODE END 1 */

/* USER CODE BEGIN 2 */
void vApplicationIdleHook( void )
{
   /* vApplicationIdleHook() will only be called if configUSE_IDLE_HOOK is set
   to 1 in FreeRTOSConfig.h. It will be called on each iteration of the idle
   task. It is essential that code added to this hook function never attempts
   to block in any way (for example, call xQueueReceive() with a block time
   specified, or call vTaskDelay()). If the application makes use of the
   vTaskDelete() API function (as this demo application does) then it is also
   important that vApplicationIdleHook() is permitted to return to its calling
   function, because it is the responsibility of the idle task to clean up
   memory allocated by the kernel to any task that has since been deleted. */
}
/* USER CODE END 2 */

/* USER CODE BEGIN 3 */
void vApplicationTickHook( void )
{
   /* This function will be called by each tick interrupt if
   configUSE_TICK_HOOK is set to 1 in FreeRTOSConfig.h. User code can be
   added here, but the tick hook is called from an interrupt context, so
   code must not attempt to block, and only the interrupt safe FreeRTOS API
   functions can be used (those that end in FromISR()). */
}
/* USER CODE END 3 */

/* USER CODE BEGIN 4 */
void vApplicationStackOverflowHook(xTaskHandle xTask, signed char *pcTaskName)
{
   /* Run time stack overflow checking is performed if
   configCHECK_FOR_STACK_OVERFLOW is defined to 1 or 2. This hook function is
   called if a stack overflow is detected. */
}
/* USER CODE END 4 */

/* USER CODE BEGIN PREPOSTSLEEP */
__weak void PreSleepProcessing(uint32_t *ulExpectedIdleTime)
{
/* place for user code */

}

__weak void PostSleepProcessing(uint32_t *ulExpectedIdleTime)
{
/* place for user code */

}
/* USER CODE END PREPOSTSLEEP */

/**
  * @brief  FreeRTOS initialization
  * @param  None
  * @retval None
  */
void MX_FREERTOS_Init(void) {
  /* USER CODE BEGIN Init */

	my_elog_init();
	  NaviKit_var_init();
  /* USER CODE END Init */

  /* USER CODE BEGIN RTOS_MUTEX */
  /* add mutexes, ... */
  /* USER CODE END RTOS_MUTEX */

  /* USER CODE BEGIN RTOS_SEMAPHORES */
  /* add semaphores, ... */
  /* USER CODE END RTOS_SEMAPHORES */

  /* USER CODE BEGIN RTOS_TIMERS */
  /* start timers, add new ones, ... */
//   PwrBtnLongPressTimerHandle = osTimerNew(PwrBtnLongPressTimerCallback, osTimerOnce, NULL, &PwrBtnLongPressTimer_attributes);
//   CustBtnLongPressTimerHandle = osTimerNew(CustBtnLongPressTimerCallback, osTimerOnce, NULL, &CustBtnLongPressTimer_attributes);
//   PwrBtnShortPressTimerHandle = osTimerNew(PwrBtnShortPressTimerCallback, osTimerOnce, NULL, &PwrBtnShortPressTimer_attributes);
//   CustBtnShortPressTimerHandle = osTimerNew(CustBtnShortPressTimerCallback, osTimerOnce, NULL, &CustBtnShortPressTimer_attributes);
//   IdleStateHoldTimerHandle = osTimerNew(IdleStateHoldTimerCallback, osTimerOnce, NULL, &IdleStateHoldTimer_attributes);

  /* USER CODE END RTOS_TIMERS */

  /* USER CODE BEGIN RTOS_QUEUES */
  /* add queues, ... */
//  LogMessageQueueHandle = osMessageQueueNew (1024, sizeof(uint8_t), &LogMessageQueue_attributes);

  /* USER CODE END RTOS_QUEUES */

  /* Create the thread(s) */
  /* creation of defaultTask */
  defaultTaskHandle = osThreadNew(StartDefaultTask, NULL, &defaultTask_attributes);

  /* creation of LedBlinkTask */
//  LedBlinkTaskHandle = osThreadNew(StartLedBlinkTask, NULL, &LedBlinkTask_attributes);

  /* creation of CoulombRead */
//  CoulombReadHandle = osThreadNew(StartCoulombRead, NULL, &CoulombRead_attributes);

  /* creation of PowerMonitTask */
//  PowerMonitTaskHandle = osThreadNew(StartPowerMonitTask, NULL, &PowerMonitTask_attributes);

  /* creation of EventDetect */
//   EventDetectHandle = osThreadNew(StartEventDetect, NULL, &EventDetect_attributes);

  /* USER CODE BEGIN RTOS_THREADS */
  /* add threads, ... */
  
	//Power--------------------------------------------
//  PowerMonitTaskHandle = osThreadNew(StartPowerMonitTask, NULL, &PowerMonitTask_attributes);


  //Button--------------------------------------------
  ButtonDetectHandle = osThreadNew(StartButtonDetect, NULL, &ButtonDetect_attributes);


  //LED--------------------------------------------
  LedBlinkTaskHandle = osThreadNew(StartLedBlinkTask, NULL, &LedBlinkTask_attributes);


  //CDC--------------------------------------------
  cdcMonitorTaskHandle = osThreadNew(StartCdcMonitorTask, NULL, &cdcMonitorTask_attributes);


  //Coulomb--------------------------------------------
//  CoulombReadHandle = osThreadNew(StartCoulombRead, NULL, &CoulombRead_attributes);


  //Elog--------------------------------------------
//   ElogInitTaskHandle = osThreadNew(StartElogInitTask, NULL, &ElogInitTask_attributes);
	ElogFlushTaskHandle = osThreadNew(StartElogFlushTask, NULL, &ElogFlushTask_attributes);
//   ElogOutputMutexHandle = osMutexNew(&ElogOutputMutex_attributes);


  //Demo--------------------------------------------
//  DemoTask1Handle = osThreadNew(StartDemoTask1, NULL, &DemoTask1_attributes);
//  DemoTask2Handle = osThreadNew(StartDemoTask2, NULL, &DemoTask2_attributes);


  /* USER CODE END RTOS_THREADS */

  /* USER CODE BEGIN RTOS_EVENTS */
  /* add events, ... */

  PwrBtnLongPressTimerHandle = osTimerNew(PwrBtnLongPressTimerCallback, osTimerOnce, NULL, &PwrBtnLongPressTimer_attributes);
  CustBtnLongPressTimerHandle = osTimerNew(CustBtnLongPressTimerCallback, osTimerOnce, NULL, &CustBtnLongPressTimer_attributes);
  PwrBtnShortPressTimerHandle = osTimerNew(PwrBtnShortPressTimerCallback, osTimerOnce, NULL, &PwrBtnShortPressTimer_attributes);
  CustBtnShortPressTimerHandle = osTimerNew(CustBtnShortPressTimerCallback, osTimerOnce, NULL, &CustBtnShortPressTimer_attributes);
  IdleStateHoldTimerHandle = osTimerNew(IdleStateHoldTimerCallback, osTimerOnce, NULL, &IdleStateHoldTimer_attributes);


  /* USER CODE END RTOS_EVENTS */

}

/* USER CODE BEGIN Header_StartDefaultTask */
/**
  * @brief  Function implementing the defaultTask thread.
  * @param  argument: Not used 
  * @retval None
  */
/* USER CODE END Header_StartDefaultTask */
void StartDefaultTask(void *argument)
{
  /* init code for USB_DEVICE */
  MX_USB_DEVICE_Init();
  /* USER CODE BEGIN StartDefaultTask */
	 osVersion_t osVersion;
	 char id_buf[20];
	 unsigned char id_size=20;

	HAL_GPIO_WritePin(USB2_FS_ENUM_CTL_GPIO_Port,USB2_FS_ENUM_CTL_Pin, GPIO_PIN_SET);
	if(isWakeUpReset()){//judge reset source form "wakeup event"

		__HAL_PWR_CLEAR_FLAG(PWR_FLAG_WU);
		__HAL_PWR_CLEAR_FLAG(PWR_FLAG_SB);

		if(HAL_GPIO_ReadPin(SYS_POWER_BTN_GPIO_Port, SYS_POWER_BTN_Pin)==GPIO_PIN_SET){
			if(HAL_GPIO_ReadPin(SYS_CUSTOM_BTN_GPIO_Port, SYS_CUSTOM_BTN_Pin)==GPIO_PIN_RESET)
				NaviKit.sys.next_sta = dfu;
			else{
				NaviKit.sys.power_btn = true;
			}
			log_i("EC Reset source :Power Button WakeUP");
		}else{
			NaviKit.sys.next_sta = idle;
			log_i("EC Reset source :RTC WakeUP");
			enter_standby_state();
		}
	}else{//judge reset source "power on"
		log_i("EC Reset source :PowerON");
		if(HAL_GPIO_ReadPin(SYS_CUSTOM_BTN_GPIO_Port, SYS_CUSTOM_BTN_Pin)==GPIO_PIN_RESET){
			log_d("EC next state isp");
			NaviKit.sys.next_sta = isp;
		}else{
			NaviKit.sys.next_sta = idle;
		}
//		TaskBeep(50,1);
	}

 	log_i("----------------------------------------------");
 	log_i("Copyright (c) Powered by www.autolabor.com.cn");
 #ifdef DEBUG
 	log_i("EC Firmware: %s[DEBUG], build: %s, %s",APP_VERSION,__DATE__ ,__TIME__);
 #else
 	log_i("EC Firmware: %s[RELEASE], build: %s, %s",APP_VERSION,__DATE__ ,__TIME__);
 #endif
 	log_i("HAL Version: 0x%X ", HAL_GetHalVersion());
 	log_i("Revision ID: 0x%X ", HAL_GetREVID());
 	log_i("Device ID: 0x%X ", HAL_GetDEVID());
 	log_i("Chip UID: 0x%X%X%X ", HAL_GetUIDw0(),HAL_GetUIDw1(),HAL_GetUIDw2());

 	if(osOK == osKernelGetInfo(&osVersion,id_buf,id_size)){
 		log_i("OS Kernel Version: %u ", osVersion.kernel);
 		log_i("OS Kernel ID: %s ",id_buf);
 	}
 	log_i("OS Kernel Tick Frequence: %d ",osKernelGetTickFreq());
 	log_i("OS Kernel System Timer Frequence: %d ",osKernelGetSysTimerFreq());
     log_i("Log Library Version: V%s",ELOG_SW_VERSION);

 	log_i("Core initial successfully");
 	log_i("----------------------------------------------");

  /* Infinite loop */
  for(;;)
  {
//	 HAL_IWDG_Refresh(&hiwdg);
	osDelay(20);
    if(NaviKit.sys.sta != NaviKit.sys.next_sta){
    	switch(NaviKit.sys.next_sta){
			case standby:  {
				enter_standby_state();
			}break;
			case idle:  {
				enter_idle_state(100);
		    	NaviKit.sys.sta = NaviKit.sys.next_sta;
			} break;
			case run: {
//				if(NaviKit.pmb.rails.main_pwr>19){
					enter_run_state(100);
					NaviKit.sys.sta = NaviKit.sys.next_sta;
//				}else{
//					NaviKit.sys.next_sta = NaviKit.sys.sta;
//					TaskBeep(500,2);
//					log_e(,"Main power not exist, retry after plug in it.");
//					 log_e("Main power is exception:%dmV",(uint32_t)(NaviKit.pmb.rails.main_pwr*1000));
//				}
			}break;
			case sleep:{
				enter_sleep_state(100);
		    	NaviKit.sys.sta = NaviKit.sys.next_sta;
			}break;
			case dfu:{
//				if(NaviKit.pmb.rails.main_pwr>19){
					enter_dfu_state(100);
					NaviKit.sys.sta = NaviKit.sys.next_sta;
//				}else{
//					NaviKit.sys.next_sta = NaviKit.sys.sta;
//					TaskBeep(500,2);
//					log_e(,"Main power not exist, retry after plug in it.");
//					 log_e("Main power is exception:%dmV",(uint32_t)(NaviKit.pmb.rails.main_pwr*1000));
//				}
			}break;
			case isp:{
				enter_isp_state();
		    	NaviKit.sys.sta = NaviKit.sys.next_sta;
			}break;
    	}
    }

	  if(NaviKit.sys.sta == idle && NaviKit.sys.next_sta == idle){//idle state
//			  if((NaviKit.pmb.sta.chrg_stat1 && NaviKit.pmb.sta.chrg_stat2)
//			  || (NaviKit.pmb.sta.chrg_stat1 && !NaviKit.pmb.sta.chrg_stat2)){//Not Charge or float charge
//				  NaviKit.sys.next_sta = standby;
//			  }

		  if(!osTimerIsRunning(IdleStateHoldTimerHandle)){
		  			osTimerStart(IdleStateHoldTimerHandle,5000);
		  }
	  }

  }
  /* USER CODE END StartDefaultTask */
}





/* Private application code --------------------------------------------------*/
/* USER CODE BEGIN Application */




/* USER CODE END Application */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
